#include <stdio.h>
#include "gfx.h"

typedef struct
{
void *ptr;
short size;
char *name;
char *type;
} Gfx;
#define G(a,t) (Gfx){a,sizeof(a),#a,#t}
#define SHORTSWAP(a) (((a)<<8)|((a)>>8))
#define LONGSWAP(a) ( SHORTSWAP((a)<<16) | SHORTSWAP((a)>>16) )

#define GFXCOUNT 23
Gfx gfx[GFXCOUNT] = {G(button1l,char),
G(button1d,char),G(button2l,char),G(button2d,char),
G(buttonmask,char),
G(keycard1l,char),G(keycard1d,char),G(keycard2l,char),G(keycard2d,char),
G(circle,short),
G(title,long),G(titlemask,long),
G(metalBG,char),
G(menumask,short),G(antimask,short),G(planets,short),
G(lightsky,short),G(medsky,short),G(darksky,short),G(starsky,short),
G(vehicleAlight,char),G(vehicleAdark,char),G(vehicleAmask,char)};

int main(int argc, char *argv[])
{
  FILE *f = fopen("oblvgfx0.bin","wb");
  char buffer[255];
  short a,i=0;

  if(!f)
  {
    printf("Couldn't open oblvgfx0.bin for writing\n");
    system("PAUSE");
    return 1;
  }
  for(a=0;a<GFXCOUNT;a++)
  {
    char dest[4];
    char src[4];
    short size;
    if(!strcmp(gfx[a].type,"long")) size=4;
    else if(!strcmp(gfx[a].type,"short")) size=2;
    else size = 1;
    
    for(i=0;i<gfx[a].size;i+=size)
    {
      memcpy(src,(unsigned char*)gfx[a].ptr+i,size);
        if(size==4)
        {
        dest[3]=src[0];
        dest[2]=src[1];
        dest[1]=src[2];
        dest[0]=src[3];
        }
        else if(size==2)
        {
        dest[1]=src[0];
        dest[0]=src[1];
        }
        else
        { dest[0] = src[0];
        }
        fwrite(dest,1,size,f);
    }
        
        
  }  
  fclose(f);
  
  sprintf(buffer,"path=%path%;..\\..\\tools");
  system(buffer);
  //sprintf(buffer,"ttpack oblvgfx0.bin gfx0.bin");
  //system(buffer);
  sprintf(buffer,"ttbin2oth -89 oblv oblvgfx0.bin oblvgfx0 oblivion");
  system(buffer);
  sprintf(buffer,"ttbin2oth -92 oblv oblvgfx0.bin oblvgfx0 oblivion");
  system(buffer);
  sprintf(buffer,"del oblvgfx0.bin");
  system(buffer);
  //sprintf(buffer,"del gfx0.bin");
  //system(buffer);
  sprintf(buffer,"move oblvgfx0.89y ../../89/oblvgfx0.89y");
  system(buffer);
  sprintf(buffer,"move oblvgfx0.9xy ../../92p_v200/oblvgfx0.9xy");
  system(buffer);
  
  
  f = fopen("..\\..\\src\\oblvgfx0.h","wt");
  if(!f)
  {
    printf("Couldn't open oblvgfx0.h for writing\n");
    system("PAUSE");
    return 1;
  }
  i=0;
  for(a=0;a<GFXCOUNT;a++)
  {
   fprintf(f,"#define %s ((unsigned %s*)(gg->gfx0+%i))\n",
        gfx[a].name,gfx[a].type,i);
    i += gfx[a].size;
  }
  
  printf("Successfully made oblvgfx0.89y/9xy and oblvgfx0.h.\n");
  printf("Uncompressed Size: %i Bytes\n\n",i);
  return 0;
}
