#include <stdio.h>
#include <string.h>
#include <stdlib.h>
unsigned char strips[4];
unsigned char* CheckStrips(char *spr, char *mask)
{
 FILE *f = fopen(mask,"rb");
 char aspr[1024];

 short i,a;
 memset(strips,0,4);
 if(!f) return strips;

 
 for(i=0;i<4;i++)
 {
   for(a=0;a<128;a++)
   {
     if(fgetc(f))
     {
       strips[i] = 1;
     }
   }
 }
 fclose(f);
 
 f = fopen(spr,"rb");
 fread(aspr,sizeof(char),1024,f);
 fclose(f);
 f = fopen(spr,"wb");
 if(strips[0]) fwrite(aspr,sizeof(char),128,f);
 if(strips[1]) fwrite(aspr+128,sizeof(char),128,f);
 if(strips[2]) fwrite(aspr+256,sizeof(char),128,f);
 if(strips[3]) fwrite(aspr+384,sizeof(char),128,f);
 if(strips[0]) fwrite(aspr+512,sizeof(char),128,f);
 if(strips[1]) fwrite(aspr+512+128,sizeof(char),128,f);
 if(strips[2]) fwrite(aspr+512+256,sizeof(char),128,f);
 if(strips[3]) fwrite(aspr+512+384,sizeof(char),128,f); 
 fclose(f);
 
 f = fopen(mask,"rb");
 fread(aspr,sizeof(char),512,f);
 fclose(f);
 f = fopen(mask,"wb");
 if(strips[0]) fwrite(aspr,sizeof(char),128,f);
 if(strips[1]) fwrite(aspr+128,sizeof(char),128,f);
 if(strips[2]) fwrite(aspr+256,sizeof(char),128,f);
 if(strips[3]) fwrite(aspr+384,sizeof(char),128,f);
 fclose(f); 

 return strips;
}

void CheckMode(char *mask,char *str, FILE **m)
{
 FILE *f = fopen(mask,"rb");
 char tall[2];
 short i,a;
 memset(tall,0,2);
 if(!f) return;

 for(i=0;i<2;i++)
 {
   for(a=0;a<256;a++)
   {
     if(fgetc(f))
     {
       tall[i] = 1;
     }
   }
 }
 if(tall[0] && tall[1])
  fprintf(*m,"%s : SPRITEMODE_SIZE64\n",str);
 else if(tall[0])
  fprintf(*m,"%s : SPRITEMODE_UPPER32\n",str);
 else if(tall[1])
  fprintf(*m,"%s : SPRITEMODE_LOWER32\n",str);
 else
  fprintf(*m,"%s : SPRITEMODE_UNUSED\n",str);

 fclose(f);
 return;
}

void HandleTexture(char *str, FILE **m)
{
 char buffer[255];
 char buf[255];
 FILE *f;
 unsigned char *strips;
 
 sprintf(buffer,"bmp\\%s.bmp",str);
 f = fopen(buffer,"rb");
 
 if(f)
 { 
 fclose(f);
 
 //BMP to BIN
 sprintf(buffer,"bmp2bin bmp\\%s.bmp bin\\%s.bin",str,str);
 system(buffer);
 sprintf(buffer,"bmp2bin bmp\\%s_.bmp bin\\%s_.bin",str,str);
 system(buffer);


 sprintf(buffer,"bin\\%s_.bin",str);
 CheckMode(buffer,str,m);
 
 //Rotates texture for FAT engine
 sprintf(buffer,"fixtex64 bin\\%s.bin bin\\%s_o.bin",str,str);
 system(buffer);
 sprintf(buffer,"fixtex64 bin\\%s_.bin bin\\%s__o.bin",str,str);
 system(buffer);

 sprintf(buffer,"bin\\%s_o.bin",str);//Sprite
 sprintf(buf,"bin\\%s__o.bin",str);//Mask
 strips = CheckStrips(buffer,buf);
 printf("%s: %i %i %i %i\n",str,strips[0],strips[1],strips[2],strips[3]);

 sprintf(buffer,"gfxcut2 bin\\%s__o.bin",str);
 system(buffer);

 //Converts BIN to text format
 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s_o.bin txt\\%s.txt",str,str);
 system(buffer);
 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s__o.bin txt\\%s_.txt",str,str);
 system(buffer);

 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s.bin txt\\%s_o.txt",str,str);
 system(buffer);
 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s_.bin txt\\%s__o.txt",str,str);
 system(buffer);

 //Adds to TXT files for compilation

 sprintf(buffer,"call end_spr_%i%i%i%i %s",strips[0],
   strips[1],strips[2],strips[3],str);
 system(buffer);
 }
 else //Multidirectional, or something
 {
  short i;
  for(i=1;i<=4;i++)
  {
    sprintf(buffer,"bmp\\%s%i-16.bmp",str,i);
    f = fopen(buffer,"rb");
    if(!f) break;
    fclose(f);
  }
    if(i==5) //Good, it's a 4 for 16 thing
    {
for(i=1;i<=4;i++)
{

 //BMP to BIN
 sprintf(buffer,"bmp2bin bmp\\%s%i-16.bmp bin\\%s%i-16.bin",str,i,str,i);
 system(buffer);
 sprintf(buffer,"bmp2bin bmp\\%s%i-16_.bmp bin\\%s%i-16_.bin",str,i,str,i);
 system(buffer);

 sprintf(buffer,"bin\\%s%i-16_.bin",str,i);
 CheckMode(buffer,str,m);
 
 //Rotates texture for FAT engine
 sprintf(buffer,"fixtex64 bin\\%s%i-16.bin bin\\%s%i-16_o.bin",str,i,str,i);
 system(buffer);
 sprintf(buffer,"fixtex64 bin\\%s%i-16_.bin bin\\%s%i-16__o.bin",str,i,str,i);
 system(buffer);

 sprintf(buffer,"bin\\%s%i-16_o.bin",str,i);//Sprite
 sprintf(buf,"bin\\%s%i-16__o.bin",str,i);//Mask
 strips = CheckStrips(buffer,buf);
 printf("%s%i-16: %i %i %i %i\n",str,i,strips[0],strips[1],strips[2],strips[3]);

 //Converts BIN to text format
 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s%i-16_o.bin txt\\%s%i-16.txt",str,i,str,i);
 system(buffer);
 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s%i-16__o.bin txt\\%s%i-16_.txt",str,i,str,i);
 system(buffer);

 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s%i-16.bin txt\\%s%i-16_o.txt",str,i,str,i);
 system(buffer);
 sprintf(buffer,"ttbin2hex -c 8 -b2 bin\\%s%i-16_.bin txt\\%s%i-16__o.txt",str,i,str,i);
 system(buffer);
}
 //Adds to TXT files for compilation
 sprintf(buffer,"call end_4_16_spr_%i%i%i%i %s",strips[0],
   strips[1],strips[2],strips[3],str);
 system(buffer);
    
    }
 }

}

char* cont(char *str)
{
 while (*str != '\n') str++;
 str++;
 return str;
}

int main(int argc, char *argv[])
{
 FILE *f,*t,*m;
 char name[255];
 char fullname[255];
 char dir[2048];
 char *dirp = dir;
 short i=1;
 short b;
 system("echo off");
 system("dir bmp /b > d.txt");
 t = fopen("d.txt","rt");
 b=0;
 m = fopen("spritemodes.txt","wt");
 while(1)
 {
 if((fgets(name,255,t))==NULL) break;
  b = 0;
  while(name[b])
  {
   if(name[b]=='\n')
     name[b] = 0;
     b++;
  }
  b=0;
  //fprintf(stderr,"\n---%s--- to \n",name);
  while(name[b])
  {
  
   if(name[b] == '.') name[b] = 0;
 /*  else if(name[b]>='0' && name[b]<='9')
   {
    if(name[b] != '1' && name[b+1]=='-'
    &&name[b+2]=='1'&&name[b+3]=='6'&&name[b+4]=='.')
    {
     name[0] = 0;
     }
    else name[b] = 0;
    }           */
   else if(name[b] == '_' && name[b+1]=='.') name[0] = 0;//Don't use the mask sprites
   b++;
  }
  strcpy(fullname,"bin\\");
  strcat(fullname,name);
  strcat(fullname,".bin");
//fprintf(stderr,"---%s---\n",name);
  HandleTexture(name,&m);
  fprintf(stderr,".");
  i++;  
 }
  if(t) fclose(t);
  if(m) fclose(m);
 i--;
 fprintf(stderr,"\n\n");
 //system("del d.txt");
  printf("\n\n%i Textures converted.\n\n",i);
  return 0;
}
